#version 430

in vec2 tex_coord;

layout(location = 0) out vec4 frag_color;

layout(location = 25) uniform sampler2D frame_tex;
layout(location = 27) uniform sampler2D pos_tex;

const float offset = 1.0 / 600.0;  
const vec3 ones = vec3(1.0);

void main()
{

    vec2 offsets[9] = vec2[](
        vec2(-offset,  offset), // top-left
        vec2( 0.0f,    offset), // top-center
        vec2( offset,  offset), // top-right
        vec2(-offset,  0.0f),   // center-left
        vec2( 0.0f,    0.0f),   // center-center
        vec2( offset,  0.0f),   // center-right
        vec2(-offset, -offset), // bottom-left
        vec2( 0.0f,   -offset), // bottom-center
        vec2( offset, -offset)  // bottom-right    
    );

    float kernel[9] = float[](
        -1, -1, -1,
        -1,  9, -1,
        -1, -1, -1
    );
    
    vec4 sampleTex[9];
    for(int i = 0; i < 9; i++)
    {
        sampleTex[i] = texture(pos_tex, tex_coord.st + offsets[i]).rgba;
    }
    vec4 col = vec4(0.0);
    for(int i = 0; i < 9; i++)
        col += sampleTex[i] * kernel[i];
    
    vec3 diff = vec3(abs(col)-sampleTex[4]);
    frag_color = vec4((step(dot(diff, ones)*0.5, 0.5))*(texture(frame_tex, tex_coord.st).rgb), 1.0);
    
    //frag_color = vec4(vec3(1-step(dot(col, ones), 0.8)) * sampleTex[4], 1.0);
    //frag_color = vec4(dot(col, ones) + 0.0*(texture(frame_tex, tex_coord.st).rgb), 1.0);
    //frag_color = vec4(vec3(1-step(dot(col, ones)-sampleTex[4], 0.8)) + 0.0*(texture(frame_tex, tex_coord.st).rgb), 1.0);
}  