#version 430
// vertex attributes 
layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

layout(location = 0) uniform mat4 view_proj_mat;
layout(location = 4) uniform mat4 model_mat;
layout(location = 8) uniform mat3 normal_mat;
uniform mat4 lightSpaceMatrix;

// inputs for fragment shader
out vec3 vert_world_position;
out vec3 vert_normal;
out vec2 vert_uv;
out vec4 vert_light_pos;
out vec3 light_direction;

void main()
{
  vec4 world_pos = model_mat * vec4(position, 1.0f);
  vert_world_position = vec3(world_pos);
  gl_Position = view_proj_mat * world_pos;

  vert_uv = uv;
  
  vert_normal = normal_mat * normal;
  
  vert_light_pos = lightSpaceMatrix * world_pos;
}