#version 430

in vec2 tex_coord;

layout(location = 0) out vec4 frag_color;

layout(location = 24) uniform vec3 gammas;
layout(location = 25) uniform sampler2D frame_tex;
layout(location = 26) uniform sampler2D bloom_tex;

const float bloom_iterations = 5.0;

void main(void) {
    vec3 bloom = texture(bloom_tex, tex_coord).rgb * bloom_iterations;
    frag_color = vec4(pow(texture(frame_tex, tex_coord).rgb + bloom, gammas), 1.0);
}