#version 430

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out vec3 light;

layout(location = 0) uniform mat4 view_proj_mat;
layout(location = 4) uniform mat4 model_mat;
layout(location = 8) uniform mat3 normal_mat;

layout(location = 30) uniform vec3 light_dir;
layout(location = 31) uniform vec3 light_color;

void main()
{
  gl_Position = view_proj_mat * model_mat * vec4(position, 1.0f);

  float ambient_intensity = 0.1f;
  float diffuse_intensity = max(dot(normal_mat * normal, light_dir), 0.0);

  light = light_color * (ambient_intensity + diffuse_intensity);
}